
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>emulsion.agent.core.emulsion_agent &#8212; EMULSION (Epidemiological Multi-Level Simulation framework)</title>
    <link rel="stylesheet" href="../../../../_static/alabaster.css" type="text/css" />
    <link rel="stylesheet" href="../../../../_static/pygments.css" type="text/css" />
    <link rel="stylesheet" href="../../../../_static/css/custom.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="../../../../" src="../../../../_static/documentation_options.js"></script>
    <script type="text/javascript" src="../../../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../../../_static/doctools.js"></script>
    <script type="text/javascript" src="../../../../_static/language_data.js"></script>
    <script async="async" type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.5/latest.js?config=TeX-AMS-MML_HTMLorMML"></script>
    <link rel="shortcut icon" href="../../../../_static/STEMAH-favicon.png"/>
    <link rel="index" title="Index" href="../../../../genindex.html" />
    <link rel="search" title="Search" href="../../../../search.html" />
   
  <link rel="stylesheet" href="../../../../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <h1>Source code for emulsion.agent.core.emulsion_agent</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">.. module:: emulsion.agent.core.emulsion_agent</span>

<span class="sd">.. moduleauthor:: Sébastien Picault &lt;sebastien.picault@inra.fr&gt;</span>

<span class="sd">Part of this code was adapted from the PADAWAN framework (S. Picault,</span>
<span class="sd">Univ. Lille).</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="c1"># [HEADER]</span>

<span class="kn">import</span> <span class="nn">abc</span>

<span class="kn">import</span> <span class="nn">numpy</span>                      <span class="k">as</span> <span class="nn">np</span>


<span class="kn">from</span>   <span class="nn">emulsion.tools.graph</span>       <span class="k">import</span> <span class="n">EdgeTypes</span>
<span class="kn">from</span>   <span class="nn">emulsion.model.functions</span>   <span class="k">import</span> <span class="n">EDGE_KEYWORDS</span>
<span class="kn">from</span>   <span class="nn">emulsion.tools.misc</span>        <span class="k">import</span> <span class="n">rates_to_probabilities</span><span class="p">,</span>\
    <span class="n">aggregate_probabilities</span><span class="p">,</span> <span class="n">probabilities_to_rates</span><span class="p">,</span> <span class="n">count_population</span><span class="p">,</span> <span class="n">AGENTS</span>

<span class="kn">from</span>   <span class="nn">emulsion.agent.core.abstract_agent</span>  <span class="k">import</span> <span class="n">AbstractAgent</span>


<span class="c1">#  ______                 _     _                                      _</span>
<span class="c1"># |  ____|               | |   (_)               /\                   | |</span>
<span class="c1"># | |__   _ __ ___  _   _| |___ _  ___  _ __    /  \   __ _  ___ _ __ | |_</span>
<span class="c1"># |  __| | &#39;_ ` _ \| | | | / __| |/ _ \| &#39;_ \  / /\ \ / _` |/ _ \ &#39;_ \| __|</span>
<span class="c1"># | |____| | | | | | |_| | \__ \ | (_) | | | |/ ____ \ (_| |  __/ | | | |_</span>
<span class="c1"># |______|_| |_| |_|\__,_|_|___/_|\___/|_| |_/_/    \_\__, |\___|_| |_|\__|</span>
<span class="c1">#                                                      __/ |</span>
<span class="c1">#                                                     |___/</span>


<div class="viewcode-block" id="EmulsionAgent"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.emulsion_agent.EmulsionAgent">[docs]</a><span class="k">class</span> <span class="nc">EmulsionAgent</span><span class="p">(</span><span class="n">AbstractAgent</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;The EmulsionAgent is the base class for multi-level</span>
<span class="sd">    epidemiologic agents. An EmulsionAgent can represent any entity</span>
<span class="sd">    involved in the epidemiologic model (individual, compartment,</span>
<span class="sd">    herd, [meta]population, etc.).</span>

<span class="sd">    Each agent contains an exchange box (in &amp; out) which is composed</span>
<span class="sd">    of a list of messages. A message is generally a dictionary of</span>
<span class="sd">    Source/Destination (In/Out) and content of exchange with</span>
<span class="sd">    Source/Destination agent.</span>

<span class="sd">    &quot;&quot;&quot;</span>
<div class="viewcode-block" id="EmulsionAgent.__init__"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.emulsion_agent.EmulsionAgent.__init__">[docs]</a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">model</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">level</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">name</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">host</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
                 <span class="n">simulation</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="o">**</span><span class="n">others</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Initialize the unit with a health state and a name.&quot;&quot;&quot;</span>
        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="o">**</span><span class="n">others</span><span class="p">)</span>
        <span class="c1"># self.statevars.health_state = health_state</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">activate</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">model</span> <span class="o">=</span> <span class="n">model</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">level</span> <span class="o">=</span> <span class="n">level</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_name</span> <span class="o">=</span> <span class="n">name</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_host</span> <span class="o">=</span> <span class="n">host</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">simulation</span> <span class="o">=</span> <span class="n">simulation</span>
        <span class="k">if</span> <span class="s1">&#39;step&#39;</span> <span class="ow">not</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">step</span> <span class="o">=</span> <span class="mi">0</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">creation_step</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">step</span>
        <span class="c1"># exchange inbox/outbox</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_inbox</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_outbox</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">level</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">level</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">default_prototypes</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">apply_prototype</span><span class="p">(</span><span class="n">name</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">default_prototypes</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">level</span><span class="p">],</span>
                                     <span class="n">execute_actions</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span></div>

<div class="viewcode-block" id="EmulsionAgent.activate"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.emulsion_agent.EmulsionAgent.activate">[docs]</a>    <span class="k">def</span> <span class="nf">activate</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Make this agent active, i.e. able to perform its processes&quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">_is_active</span> <span class="o">=</span> <span class="kc">True</span></div>

<div class="viewcode-block" id="EmulsionAgent.deactivate"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.emulsion_agent.EmulsionAgent.deactivate">[docs]</a>    <span class="k">def</span> <span class="nf">deactivate</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Make this agent inactive, i.e. unable to perform its processes&quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">_is_active</span> <span class="o">=</span> <span class="kc">False</span></div>

<div class="viewcode-block" id="EmulsionAgent.detach_model"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.emulsion_agent.EmulsionAgent.detach_model">[docs]</a>    <span class="k">def</span> <span class="nf">detach_model</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Remove the reference to the model in all agents. Required before</span>
<span class="sd">        serialization.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">model</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">simulation</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_last_prototype</span> <span class="o">=</span> <span class="kc">None</span></div>

<div class="viewcode-block" id="EmulsionAgent.upper_level"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.emulsion_agent.EmulsionAgent.upper_level">[docs]</a>    <span class="k">def</span> <span class="nf">upper_level</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">init</span><span class="o">=</span><span class="kc">True</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Return the &#39;upper level&#39; for this agent, i.e. the first host with</span>
<span class="sd">        a not-None level attribute.</span>

<span class="sd">        TAG: USER</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">level</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="ow">and</span> <span class="ow">not</span> <span class="n">init</span><span class="p">:</span>
            <span class="k">return</span> <span class="bp">self</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_host</span><span class="p">()</span><span class="o">.</span><span class="n">upper_level</span><span class="p">(</span><span class="n">init</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span></div>

<div class="viewcode-block" id="EmulsionAgent.top_level"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.emulsion_agent.EmulsionAgent.top_level">[docs]</a>    <span class="k">def</span> <span class="nf">top_level</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Return the highest level used in the simulation&quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_host</span><span class="p">()</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">return</span> <span class="bp">self</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">upper_level</span><span class="p">()</span><span class="o">.</span><span class="n">top_level</span><span class="p">()</span></div>

<div class="viewcode-block" id="EmulsionAgent.log_path"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.emulsion_agent.EmulsionAgent.log_path">[docs]</a>    <span class="k">def</span> <span class="nf">log_path</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Return the path to the log file for the current simulation&quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">top_level</span><span class="p">()</span><span class="o">.</span><span class="n">simulation</span><span class="o">.</span><span class="n">log_path</span><span class="p">()</span></div>

    <span class="nd">@property</span>
    <span class="k">def</span> <span class="nf">name</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Return the name of the unit. If no name was provided during</span>
<span class="sd">        instantiation,  the class name is returned.</span>

<span class="sd">        TAG: USER</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">_name</span> <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">_name</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span>\
            <span class="k">else</span> <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="fm">__repr__</span><span class="p">()</span> <span class="c1"># self.__class__.__name__</span>

    <span class="k">def</span> <span class="nf">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">name</span>


<div class="viewcode-block" id="EmulsionAgent.evolve"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.emulsion_agent.EmulsionAgent.evolve">[docs]</a>    <span class="k">def</span> <span class="nf">evolve</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">machine</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;This method is aimed at defining what has systematically to</span>
<span class="sd">        be done in the unit at each time step (e.g. age change...). It</span>
<span class="sd">        has to be overriden if needed in subclasses.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">step</span> <span class="o">+=</span> <span class="mi">1</span></div>

<div class="viewcode-block" id="EmulsionAgent.get_host"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.emulsion_agent.EmulsionAgent.get_host">[docs]</a>    <span class="k">def</span> <span class="nf">get_host</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">key</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Return the host of the current unit.</span>

<span class="sd">        TAG: USER</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">_host</span></div>

<div class="viewcode-block" id="EmulsionAgent.get_content"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.emulsion_agent.EmulsionAgent.get_content">[docs]</a>    <span class="nd">@abc</span><span class="o">.</span><span class="n">abstractmethod</span>
    <span class="k">def</span> <span class="nf">get_content</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Return either the population (number) of the current unit,</span>
<span class="sd">        or the list of agents contained in the current unit. The</span>
<span class="sd">        output is a tuple with either (&#39;population&#39;, qty) or (&#39;agents&#39;, list).</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">pass</span></div>

<div class="viewcode-block" id="EmulsionAgent.do_state_actions"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.emulsion_agent.EmulsionAgent.do_state_actions">[docs]</a>    <span class="k">def</span> <span class="nf">do_state_actions</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">event</span><span class="p">,</span> <span class="n">state_machine</span><span class="p">,</span> <span class="n">state_name</span><span class="p">,</span>
                         <span class="n">population</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">agents</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="o">**</span><span class="n">_</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Perform the actions associated to the current state. If the</span>
<span class="sd">        unit is a ViewAgent, actions are actually performed by each</span>
<span class="sd">        unit of the specified agents list, in turn. Otherwise, the</span>
<span class="sd">        actions are performed according to the population, which is</span>
<span class="sd">        expected to be a number.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># if actions are actually associated to the current state of</span>
        <span class="c1"># the state machine...</span>
           <span class="c1"># ... and to the &#39;event&#39; (enter/exit/stay)</span>
        <span class="k">if</span> <span class="n">state_name</span> <span class="ow">in</span> <span class="n">state_machine</span><span class="o">.</span><span class="n">state_actions</span>\
           <span class="ow">and</span> <span class="n">event</span> <span class="ow">in</span> <span class="n">state_machine</span><span class="o">.</span><span class="n">state_actions</span><span class="p">[</span><span class="n">state_name</span><span class="p">]:</span>
            <span class="c1"># print(f&#39;Doing state actions {event} for {state_machine}\n\tfor {state_name}&#39;)</span>
            <span class="c1"># retrieve the list of actions</span>
            <span class="n">l_actions</span> <span class="o">=</span> <span class="n">state_machine</span><span class="o">.</span><span class="n">state_actions</span><span class="p">[</span><span class="n">state_name</span><span class="p">][</span><span class="n">event</span><span class="p">]</span>
            <span class="c1"># ask the current unit to perform the actions with the</span>
            <span class="c1"># specified population</span>
            <span class="c1"># print(f&#39;\t{l_actions}&#39;)</span>
            <span class="k">for</span> <span class="n">action</span> <span class="ow">in</span> <span class="n">l_actions</span><span class="p">:</span>
                <span class="n">action</span><span class="o">.</span><span class="n">execute_action</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">population</span><span class="o">=</span><span class="n">population</span><span class="p">,</span> <span class="n">agents</span><span class="o">=</span><span class="n">agents</span><span class="p">)</span></div>

<div class="viewcode-block" id="EmulsionAgent.do_edge_actions"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.emulsion_agent.EmulsionAgent.do_edge_actions">[docs]</a>    <span class="k">def</span> <span class="nf">do_edge_actions</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">actions</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">population</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">agents</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Perform the actions associated to a transition between</span>
<span class="sd">        states. If the unit is a ViewCompartment, actions are actually</span>
<span class="sd">        performed by each unit of the specified agents list, in</span>
<span class="sd">        turn. Otherwise, the actions are performed according to the</span>
<span class="sd">        population, which is expected to be a number.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># # if actions are actually associated to the current edge...</span>
        <span class="c1">#    # ... and to the &#39;event&#39; (cross)</span>
        <span class="c1"># if from_ in state_machine.edge_actions\</span>
        <span class="c1">#    and to_ in state_machine.edge_actions[from_]\</span>
        <span class="c1">#    and event in state_machine.edge_actions[from_][to_]:</span>
        <span class="c1">#     # retrieve the list of actions</span>
        <span class="c1">#     l_actions = state_machine.edge_actions[from_][to_][event]</span>
        <span class="c1">#     # ask the current unit to perform the actions with the</span>
        <span class="c1">#     # specified population</span>
        <span class="k">for</span> <span class="n">action</span> <span class="ow">in</span> <span class="n">actions</span><span class="p">:</span>
<span class="c1">#            print(action)</span>
            <span class="n">action</span><span class="o">.</span><span class="n">execute_action</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">population</span><span class="o">=</span><span class="n">population</span><span class="p">,</span> <span class="n">agents</span><span class="o">=</span><span class="n">agents</span><span class="p">)</span></div>


<div class="viewcode-block" id="EmulsionAgent.next_states_from"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.emulsion_agent.EmulsionAgent.next_states_from">[docs]</a>    <span class="k">def</span> <span class="nf">next_states_from</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">initial_state</span><span class="p">,</span> <span class="n">state_machine</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Return a list of tuples composed of:</span>

<span class="sd">        - each of the possible states reachable from the specified</span>
<span class="sd">        initial state (some depending on a condition)</span>

<span class="sd">        - the transition rate, probability or amount to each state in</span>
<span class="sd">        the specified state_machine (possible clauses: &#39;rate&#39;,</span>
<span class="sd">        &#39;proba&#39;, &#39;amount&#39;, &#39;amount-all-but&#39; with the actual value)</span>

<span class="sd">        - a tuple indicating who can cross the edge, depending on</span>
<span class="sd">        conditions (either (&#39;population&#39;, qty) or (&#39;agents&#39;, list))</span>

<span class="sd">        - the list of actions to perform when crossing the edge (if</span>
<span class="sd">        any).</span>

<span class="sd">        The conditions, rates and probabilities may depend on the state</span>
<span class="sd">        variables or properties of the current unit.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">result</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="c1"># remove unfulfilled &#39;when&#39; clauses if any</span>
        <span class="k">for</span> <span class="p">(</span><span class="n">state</span><span class="p">,</span> <span class="n">props</span><span class="p">)</span> <span class="ow">in</span> <span class="n">state_machine</span><span class="o">.</span><span class="n">graph</span><span class="o">.</span><span class="n">edges_from</span><span class="p">(</span><span class="n">initial_state</span><span class="p">,</span>
                                                             <span class="n">type_id</span><span class="o">=</span><span class="n">EdgeTypes</span><span class="o">.</span><span class="n">TRANSITION</span><span class="p">):</span>
            <span class="k">if</span> <span class="s1">&#39;when&#39;</span> <span class="ow">in</span> <span class="n">props</span><span class="p">:</span>
                <span class="n">when</span> <span class="o">=</span> <span class="n">state_machine</span><span class="o">.</span><span class="n">get_value</span><span class="p">(</span><span class="n">props</span><span class="p">[</span><span class="s1">&#39;when&#39;</span><span class="p">])</span>
                <span class="n">fulfilled</span> <span class="o">=</span> <span class="n">when</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span> <span class="k">if</span> <span class="n">callable</span><span class="p">(</span><span class="n">when</span><span class="p">)</span> <span class="k">else</span> <span class="n">when</span>
                <span class="k">if</span> <span class="ow">not</span> <span class="n">fulfilled</span><span class="p">:</span>
                    <span class="k">continue</span>
            <span class="n">cond_result</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_content</span><span class="p">()</span>
            <span class="c1"># if any condition, evaluate it</span>
            <span class="k">if</span> <span class="s1">&#39;cond&#39;</span> <span class="ow">in</span> <span class="n">props</span><span class="p">:</span>
                <span class="n">cond</span> <span class="o">=</span> <span class="n">state_machine</span><span class="o">.</span><span class="n">get_value</span><span class="p">(</span><span class="n">props</span><span class="p">[</span><span class="s1">&#39;cond&#39;</span><span class="p">])</span>
                <span class="c1"># compute the content tuple (either (&#39;population&#39;, qty)</span>
                <span class="c1"># or (&#39;agents&#39;, lsit)) which fulfils the condition</span>
                <span class="n">cond_result</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">evaluate_condition</span><span class="p">(</span><span class="n">cond</span><span class="p">)</span>
            <span class="c1"># only edges with condition fulfilled are taken into account</span>
            <span class="k">if</span> <span class="n">cond_result</span><span class="p">:</span>
                <span class="c1"># print(cond_result)</span>
                <span class="n">flux</span> <span class="o">=</span> <span class="kc">None</span>
                <span class="k">for</span> <span class="n">keyword</span> <span class="ow">in</span> <span class="n">EDGE_KEYWORDS</span><span class="p">:</span>
                    <span class="k">if</span> <span class="n">keyword</span> <span class="ow">in</span> <span class="n">props</span><span class="p">:</span>
                        <span class="n">flux</span> <span class="o">=</span> <span class="n">keyword</span>
                        <span class="k">break</span>
                <span class="n">value</span> <span class="o">=</span> <span class="n">state_machine</span><span class="o">.</span><span class="n">get_value</span><span class="p">(</span><span class="n">props</span><span class="p">[</span><span class="n">flux</span><span class="p">])</span>
                <span class="n">actions</span> <span class="o">=</span> <span class="n">props</span><span class="p">[</span><span class="s1">&#39;actions&#39;</span><span class="p">]</span> <span class="k">if</span> <span class="s1">&#39;actions&#39;</span> <span class="ow">in</span> <span class="n">props</span> <span class="k">else</span> <span class="p">[]</span>
                <span class="k">if</span> <span class="n">callable</span><span class="p">(</span><span class="n">value</span><span class="p">):</span>
                    <span class="n">value</span> <span class="o">=</span> <span class="n">value</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span>
                <span class="k">if</span> <span class="n">value</span> <span class="o">&gt;</span> <span class="mi">0</span> <span class="ow">or</span> <span class="n">flux</span> <span class="o">==</span> <span class="s1">&#39;amount-all-but&#39;</span><span class="p">:</span>
                    <span class="n">result</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="n">state</span><span class="p">,</span> <span class="n">flux</span><span class="p">,</span> <span class="n">value</span><span class="p">,</span> <span class="n">cond_result</span><span class="p">,</span> <span class="n">actions</span><span class="p">))</span>
        <span class="k">return</span> <span class="n">result</span></div>

<div class="viewcode-block" id="EmulsionAgent.production_from"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.emulsion_agent.EmulsionAgent.production_from">[docs]</a>    <span class="k">def</span> <span class="nf">production_from</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">initial_state</span><span class="p">,</span> <span class="n">state_machine</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Return a list of tuples composed of:</span>

<span class="sd">        - each of the possible states that can be produced from the specified</span>
<span class="sd">        initial state (some depending on a condition)</span>

<span class="sd">        - the transition rate, probability or amount to each state in</span>
<span class="sd">        the specified state_machine (possible clauses: &#39;rate&#39;,</span>
<span class="sd">        &#39;proba&#39;, &#39;amount&#39;, &#39;amount-all-but&#39; with the actual value)</span>

<span class="sd">        - a tuple indicating who can produce cross the edge, depending on</span>
<span class="sd">        conditions (either (&#39;population&#39;, qty) or (&#39;agents&#39;, list))</span>

<span class="sd">        - the prototypes of agents produced through the edge (if</span>
<span class="sd">        any).</span>

<span class="sd">        The conditions, rates and probabilities may depend on the state</span>
<span class="sd">        variables or properties of the current unit.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">result</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="c1"># remove unfulfilled &#39;when&#39; clauses if any</span>
        <span class="k">for</span> <span class="p">(</span><span class="n">state</span><span class="p">,</span> <span class="n">props</span><span class="p">)</span> <span class="ow">in</span> <span class="n">state_machine</span><span class="o">.</span><span class="n">graph</span><span class="o">.</span><span class="n">edges_from</span><span class="p">(</span><span class="n">initial_state</span><span class="p">,</span>
                                                             <span class="n">type_id</span><span class="o">=</span><span class="n">EdgeTypes</span><span class="o">.</span><span class="n">PRODUCTION</span><span class="p">):</span>
            <span class="k">if</span> <span class="s1">&#39;when&#39;</span> <span class="ow">in</span> <span class="n">props</span><span class="p">:</span>
                <span class="n">when</span> <span class="o">=</span> <span class="n">state_machine</span><span class="o">.</span><span class="n">get_value</span><span class="p">(</span><span class="n">props</span><span class="p">[</span><span class="s1">&#39;when&#39;</span><span class="p">])</span>
                <span class="n">fulfilled</span> <span class="o">=</span> <span class="n">when</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span> <span class="k">if</span> <span class="n">callable</span><span class="p">(</span><span class="n">when</span><span class="p">)</span> <span class="k">else</span> <span class="n">when</span>
                <span class="k">if</span> <span class="ow">not</span> <span class="n">fulfilled</span><span class="p">:</span>
                    <span class="k">continue</span>
            <span class="n">cond_result</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_content</span><span class="p">()</span>
            <span class="c1"># if any condition, evaluate it</span>
            <span class="k">if</span> <span class="s1">&#39;cond&#39;</span> <span class="ow">in</span> <span class="n">props</span><span class="p">:</span>
                <span class="n">cond</span> <span class="o">=</span> <span class="n">state_machine</span><span class="o">.</span><span class="n">get_value</span><span class="p">(</span><span class="n">props</span><span class="p">[</span><span class="s1">&#39;cond&#39;</span><span class="p">])</span>
                <span class="c1"># compute the content tuple (either (&#39;population&#39;, qty)</span>
                <span class="c1"># or (&#39;agents&#39;, lsit)) which fulfils the condition</span>
                <span class="n">cond_result</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">evaluate_condition</span><span class="p">(</span><span class="n">cond</span><span class="p">)</span>
            <span class="c1"># only edges with condition fulfilled are taken into account</span>
            <span class="k">if</span> <span class="n">cond_result</span><span class="p">:</span>
                <span class="c1"># print(cond_result)</span>
                <span class="n">flux</span> <span class="o">=</span> <span class="kc">None</span>
                <span class="k">for</span> <span class="n">keyword</span> <span class="ow">in</span> <span class="n">EDGE_KEYWORDS</span><span class="p">:</span>
                    <span class="k">if</span> <span class="n">keyword</span> <span class="ow">in</span> <span class="n">props</span><span class="p">:</span>
                        <span class="n">flux</span> <span class="o">=</span> <span class="n">keyword</span>
                        <span class="k">break</span>
                <span class="n">value</span> <span class="o">=</span> <span class="n">state_machine</span><span class="o">.</span><span class="n">get_value</span><span class="p">(</span><span class="n">props</span><span class="p">[</span><span class="n">flux</span><span class="p">])</span>
                <span class="n">protos</span> <span class="o">=</span> <span class="n">props</span><span class="p">[</span><span class="s1">&#39;prototype&#39;</span><span class="p">]</span> <span class="k">if</span> <span class="s1">&#39;prototype&#39;</span> <span class="ow">in</span> <span class="n">props</span> <span class="k">else</span> <span class="kc">None</span>
                <span class="k">if</span> <span class="n">callable</span><span class="p">(</span><span class="n">value</span><span class="p">):</span>
                    <span class="n">value</span> <span class="o">=</span> <span class="n">value</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span>
                <span class="k">if</span> <span class="n">value</span> <span class="o">&gt;</span> <span class="mi">0</span> <span class="ow">or</span> <span class="n">flux</span> <span class="o">==</span> <span class="s1">&#39;amount-all-but&#39;</span><span class="p">:</span>
                    <span class="n">result</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="n">state</span><span class="p">,</span> <span class="n">flux</span><span class="p">,</span> <span class="n">value</span><span class="p">,</span> <span class="n">cond_result</span><span class="p">,</span> <span class="n">protos</span><span class="p">))</span>
        <span class="k">return</span> <span class="n">result</span></div>


    <span class="k">def</span> <span class="nf">_compute_production</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">value</span><span class="p">,</span> <span class="n">flux</span><span class="p">,</span> <span class="n">pop_size</span><span class="p">,</span> <span class="n">stochastic</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Compute the values of production edges.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># ALL PRODUCTIONS COME FROM THE SAME POPULATION</span>
        <span class="c1"># (reference_pop) The `values` can represent : 1) amounts - in</span>
        <span class="c1"># that case no transformation occurs, 2) probabilities - in</span>
        <span class="c1"># that case the values must be converted to rates if the</span>
        <span class="c1"># target compartment is deterministic, otherwise the step</span>
        <span class="c1"># duration must be taken into account; 3) rates - computed</span>
        <span class="c1"># using Poisson distribution if the target compartment is</span>
        <span class="c1"># stochastic</span>
        <span class="k">if</span> <span class="n">flux</span> <span class="o">==</span> <span class="s1">&#39;amount-all-but&#39;</span><span class="p">:</span>
            <span class="n">amount</span> <span class="o">=</span> <span class="nb">max</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">pop_size</span> <span class="o">-</span> <span class="n">value</span><span class="p">)</span>
        <span class="k">elif</span> <span class="n">flux</span> <span class="o">==</span> <span class="s1">&#39;amount&#39;</span><span class="p">:</span>
            <span class="n">amount</span> <span class="o">=</span> <span class="n">value</span>
        <span class="k">elif</span> <span class="n">flux</span> <span class="o">==</span> <span class="s1">&#39;proba&#39;</span><span class="p">:</span>
            <span class="c1"># if stochastic uses binomial</span>
            <span class="k">if</span> <span class="n">stochastic</span><span class="p">:</span>
                <span class="c1"># aggregate probability wrt the time step duration</span>
                <span class="n">value</span> <span class="o">=</span> <span class="n">aggregate_probabilities</span><span class="p">([</span><span class="n">value</span><span class="p">],</span> <span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">delta_t</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span>
                <span class="n">amount</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">random</span><span class="o">.</span><span class="n">binomial</span><span class="p">(</span><span class="n">pop_size</span><span class="p">,</span> <span class="n">value</span><span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="c1"># otherwise treat proba as proportion</span>
                <span class="n">amount</span> <span class="o">=</span> <span class="n">pop_size</span> <span class="o">*</span> <span class="n">value</span>
        <span class="k">elif</span> <span class="n">flux</span> <span class="o">==</span> <span class="s1">&#39;rate&#39;</span><span class="p">:</span>
            <span class="c1"># if stochastic: use Poisson distribution</span>
            <span class="k">if</span> <span class="n">stochastic</span><span class="p">:</span>
                <span class="n">amount</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">random</span><span class="o">.</span><span class="n">poisson</span><span class="p">(</span><span class="n">value</span> <span class="o">*</span> <span class="n">pop_size</span> <span class="o">*</span> <span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">delta_t</span><span class="p">)</span>
                <span class="c1"># amount = np.random.binomial(pop_size, 1-np.exp(-value * self.model.delta_t))</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="c1"># consider rate as a speed</span>
                <span class="c1"># S = S0 exp(rate * dt) =&gt; S += S * (exp(rate*dt) - 1)</span>
                <span class="c1"># amount = value * pop_size * self.model.delta_t</span>
                <span class="n">amount</span> <span class="o">=</span> <span class="n">pop_size</span> <span class="o">*</span> <span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">exp</span><span class="p">(</span><span class="n">value</span> <span class="o">*</span> <span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">delta_t</span><span class="p">)</span> <span class="o">-</span> <span class="mi">1</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>                   <span class="c1"># should not happen !</span>
            <span class="n">amount</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">return</span> <span class="n">amount</span>


    <span class="k">def</span> <span class="nf">_compute_values_for_unique_population</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span>
                                              <span class="n">values</span><span class="p">,</span>
                                              <span class="n">flux</span><span class="p">,</span>
                                              <span class="n">reference_pop</span><span class="p">,</span>
                                              <span class="n">stochastic</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Restructure the values according to the situation, for</span>
<span class="sd">        edges concerning the same population.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># ALL TRANSITIONS AFFECT THE SAME POPULATION (reference_pop)</span>
        <span class="c1"># The `values` can represent : 1) amounts - in that case no</span>
        <span class="c1"># transformation occurs, 2) probabilities - in that case the</span>
        <span class="c1"># values must be converted to rates if the target compartment</span>
        <span class="c1"># is deterministic, otherwise the step duration must be taken</span>
        <span class="c1"># into account; 3) rates - in that case the values must be</span>
        <span class="c1"># converted to probabilities if the target compartment is</span>
        <span class="c1"># stochastic</span>
        <span class="c1"># print(&#39;IDENTICAL&#39;)</span>
        <span class="n">available_flux</span> <span class="o">=</span> <span class="nb">set</span><span class="p">(</span><span class="n">flux</span><span class="p">)</span>
        <span class="c1"># try:</span>
        <span class="k">assert</span> <span class="nb">len</span><span class="p">(</span><span class="n">available_flux</span><span class="p">)</span> <span class="o">==</span> <span class="mi">1</span> <span class="ow">or</span> <span class="n">available_flux</span> <span class="o">==</span> <span class="nb">set</span><span class="p">([</span><span class="s1">&#39;amount&#39;</span><span class="p">,</span> <span class="s1">&#39;amount-all-but&#39;</span><span class="p">])</span>
        <span class="c1"># except:</span>
        <span class="c1">#     print(available_flux)</span>

        <span class="n">method</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">if</span> <span class="s1">&#39;amount&#39;</span> <span class="ow">in</span> <span class="n">available_flux</span> <span class="ow">or</span> <span class="s1">&#39;amount-all-but&#39;</span> <span class="ow">in</span> <span class="n">available_flux</span><span class="p">:</span>
            <span class="c1"># handle values as amounts</span>
            <span class="n">method</span> <span class="o">=</span> <span class="s1">&#39;amount&#39;</span>
            <span class="n">total_ref_pop</span> <span class="o">=</span> <span class="n">count_population</span><span class="p">(</span><span class="n">reference_pop</span><span class="p">)</span>
            <span class="c1"># check that values are between 0 and the population size,</span>
            <span class="c1"># if needed invert &#39;amount-all-but&#39; values</span>
            <span class="n">values</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">([</span><span class="nb">max</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="nb">min</span><span class="p">(</span><span class="n">total_ref_pop</span><span class="o">-</span><span class="n">v</span><span class="p">,</span> <span class="n">total_ref_pop</span><span class="p">))</span>\
                              <span class="k">if</span> <span class="n">f</span> <span class="o">==</span> <span class="s1">&#39;amount-all-but&#39;</span>\
                              <span class="k">else</span> <span class="nb">max</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="nb">min</span><span class="p">(</span><span class="n">v</span><span class="p">,</span> <span class="n">total_ref_pop</span><span class="p">))</span>
                            <span class="k">for</span> <span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">v</span><span class="p">)</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">flux</span><span class="p">,</span> <span class="n">values</span><span class="p">)])</span>
            <span class="c1"># when finished the length of values is the number of</span>
            <span class="c1"># outgoing edges</span>
            <span class="c1"># print(&#39;AMOUNT&#39;, values)</span>
        <span class="k">elif</span> <span class="s1">&#39;proba&#39;</span> <span class="ow">in</span> <span class="n">available_flux</span><span class="p">:</span>
            <span class="k">if</span> <span class="ow">not</span> <span class="n">stochastic</span><span class="p">:</span>
                <span class="c1"># then if the target compartment is deterministic,</span>
                <span class="c1"># probabilities must be converted into rates</span>
                <span class="c1"># print(&#39;PROBA -&gt; RATES&#39;, values)</span>
                <span class="n">values</span> <span class="o">=</span> <span class="n">probabilities_to_rates</span><span class="p">(</span><span class="n">values</span> <span class="o">+</span> <span class="p">(</span><span class="mi">1</span> <span class="o">-</span> <span class="nb">sum</span><span class="p">(</span><span class="n">values</span><span class="p">),))</span>
                <span class="c1"># when finished the length of values is the number of</span>
                <span class="c1"># outgoing edges</span>
                <span class="c1"># print(values)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="c1"># aggregate probabilities wrt the time step duration</span>
                <span class="n">values</span> <span class="o">=</span> <span class="n">aggregate_probabilities</span><span class="p">(</span><span class="n">values</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">delta_t</span><span class="p">)</span>
                <span class="n">values</span> <span class="o">=</span> <span class="n">values</span> <span class="o">+</span> <span class="p">(</span><span class="mi">1</span> <span class="o">-</span> <span class="nb">sum</span><span class="p">(</span><span class="n">values</span><span class="p">),)</span>
                <span class="c1"># when finished the length of values is the number of</span>
                <span class="c1"># outgoing edges + 1</span>
                <span class="c1"># print(&#39;PROBA&#39;, values)</span>
        <span class="k">elif</span> <span class="ow">not</span> <span class="n">stochastic</span><span class="p">:</span>
            <span class="c1"># print(&#39;RATES&#39;, values)</span>
            <span class="k">pass</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="c1"># otherwise values are transformed from rates to</span>
            <span class="c1"># probabilities</span>
            <span class="n">values</span> <span class="o">=</span> <span class="n">rates_to_probabilities</span><span class="p">(</span><span class="nb">sum</span><span class="p">(</span><span class="n">values</span><span class="p">),</span>
                                            <span class="n">values</span><span class="p">,</span>
                                            <span class="n">delta_t</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">delta_t</span><span class="p">)</span>
            <span class="c1"># when finished the length of values is the number of</span>
            <span class="c1"># outgoing edges + 1</span>
            <span class="c1"># print(&quot;RATES -&gt; PROBAS&quot;, values)</span>
        <span class="k">return</span> <span class="n">values</span><span class="p">,</span> <span class="n">method</span>

    <span class="k">def</span> <span class="nf">_compute_values_for_multiple_populations</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span>
                                                 <span class="n">values</span><span class="p">,</span>
                                                 <span class="n">flux</span><span class="p">,</span>
                                                 <span class="n">populations</span><span class="p">,</span>
                                                 <span class="n">stochastic</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Restructure the values according to the situation, for</span>
<span class="sd">        edges concerning distinct populations.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># IN THAT CASE, EACH POSSIBLE TRANSITION IS RELATED TO A</span>
        <span class="c1"># SPECIFIC SUBGROUP OF THE COMPART.</span>
        <span class="c1">### IMPORTANT: we assume that all conditions are disjoint,</span>
        <span class="c1">### i.e. there is no intersection between the populations. IF</span>
        <span class="c1">### NOT THE CASE, this means that the model is not really</span>
        <span class="c1">### consistent, and the calculation of probabilities should be</span>
        <span class="c1">### done on each individual... thus why use a StructuredView</span>
        <span class="c1">### instead of a set of EvolvingAtom ???</span>
        <span class="c1"># print(&#39;MULTIPLE&#39;)</span>
        <span class="n">pop_sets</span> <span class="o">=</span> <span class="p">[</span><span class="n">SortedSet</span><span class="p">(</span><span class="n">pop</span><span class="p">[</span><span class="n">AGENTS</span><span class="p">])</span> <span class="k">for</span> <span class="n">pop</span> <span class="ow">in</span> <span class="n">populations</span><span class="p">]</span>
        <span class="c1"># pop_sets must be disjoint</span>
        <span class="k">assert</span><span class="p">(</span><span class="ow">not</span> <span class="nb">any</span><span class="p">([</span><span class="n">pop_sets</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="o">&amp;</span> <span class="n">pop_sets</span><span class="p">[</span><span class="n">j</span><span class="p">]</span>
                        <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">pop_sets</span><span class="p">)</span><span class="o">-</span><span class="mi">1</span><span class="p">)</span>
                        <span class="k">for</span> <span class="n">j</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">i</span><span class="o">+</span><span class="mi">1</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">pop_sets</span><span class="p">))]))</span>
        <span class="c1"># binomial values must be computed for each transition to</span>
        <span class="c1"># determine how many units among the candidates will cross the</span>
        <span class="c1"># transition, thus we need probabilities. If all values are</span>
        <span class="c1"># given as rates, they must be transformed</span>
        <span class="n">method</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="n">available_flux</span> <span class="o">=</span> <span class="nb">set</span><span class="p">(</span><span class="n">flux</span><span class="p">)</span>
        <span class="c1"># try:</span>
        <span class="k">assert</span> <span class="nb">len</span><span class="p">(</span><span class="n">available_flux</span><span class="p">)</span> <span class="o">==</span> <span class="mi">1</span> <span class="ow">or</span> <span class="n">available_flux</span> <span class="o">==</span> <span class="nb">set</span><span class="p">([</span><span class="s1">&#39;amount&#39;</span><span class="p">,</span> <span class="s1">&#39;amount-all-but&#39;</span><span class="p">])</span>
        <span class="c1"># except:</span>
        <span class="c1">#     print(available_flux)</span>

        <span class="k">if</span> <span class="n">available_flux</span> <span class="o">==</span> <span class="p">{</span><span class="s1">&#39;rate&#39;</span><span class="p">}</span> <span class="ow">and</span> <span class="n">stochastic</span><span class="p">:</span>
            <span class="c1"># values are transformed from rates to probabilities</span>
            <span class="n">values</span> <span class="o">=</span> <span class="n">rates_to_probabilities</span><span class="p">(</span><span class="nb">sum</span><span class="p">(</span><span class="n">values</span><span class="p">),</span>
                                            <span class="n">values</span><span class="p">,</span>
                                            <span class="n">delta_t</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">delta_t</span><span class="p">)</span>
            <span class="c1"># print(&#39;RATES -&gt; PROBAS&#39;, values)</span>
        <span class="k">elif</span> <span class="s1">&#39;amount&#39;</span> <span class="ow">in</span> <span class="n">available_flux</span> <span class="ow">or</span> <span class="s1">&#39;amount-all-but&#39;</span> <span class="ow">in</span> <span class="n">available_flux</span><span class="p">:</span>
            <span class="n">method</span> <span class="o">=</span> <span class="s1">&#39;amount&#39;</span>
            <span class="n">pops</span> <span class="o">=</span> <span class="p">[</span><span class="nb">len</span><span class="p">(</span><span class="n">p</span><span class="p">)</span> <span class="k">for</span> <span class="n">p</span> <span class="ow">in</span> <span class="n">pop_sets</span><span class="p">]</span>
            <span class="n">values</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">([</span><span class="nb">max</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="nb">min</span><span class="p">(</span><span class="n">pop</span><span class="o">-</span><span class="n">v</span><span class="p">,</span> <span class="n">pop</span><span class="p">))</span>\
                              <span class="k">if</span> <span class="n">f</span> <span class="o">==</span> <span class="s1">&#39;amount-all-but&#39;</span>\
                              <span class="k">else</span> <span class="nb">max</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="nb">min</span><span class="p">(</span><span class="n">v</span><span class="p">,</span> <span class="n">pop</span><span class="p">))</span>
                            <span class="k">for</span> <span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">v</span><span class="p">,</span> <span class="n">pop</span><span class="p">)</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">flux</span><span class="p">,</span> <span class="n">values</span><span class="p">,</span> <span class="n">pops</span><span class="p">)])</span>
            <span class="n">values</span> <span class="o">=</span> <span class="n">values</span> <span class="c1">#+ (1 - sum(values),)</span>
            <span class="c1"># print(&#39;AMOUNTS:&#39;, values)</span>
        <span class="k">elif</span> <span class="s1">&#39;proba&#39;</span> <span class="ow">in</span> <span class="n">available_flux</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">stochastic</span><span class="p">:</span>
                <span class="c1"># values must be aggregated wrt the times step duration</span>
                <span class="n">values</span> <span class="o">=</span> <span class="n">aggregate_probabilities</span><span class="p">(</span><span class="n">values</span><span class="p">,</span>
                                                 <span class="n">delta_t</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">delta_t</span><span class="p">)</span>
                <span class="n">values</span> <span class="o">=</span> <span class="n">values</span> <span class="o">+</span> <span class="p">(</span><span class="mi">1</span> <span class="o">-</span> <span class="nb">sum</span><span class="p">(</span><span class="n">values</span><span class="p">),)</span>
                <span class="c1"># print(&#39;PROBAS:&#39;, values)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="c1"># values must be transformed from probabilities to rates</span>
                <span class="c1"># print(&#39;PROBABILITIES -&gt; RATES&#39;, values)</span>
                <span class="n">values</span> <span class="o">=</span> <span class="n">probabilities_to_rates</span><span class="p">(</span><span class="n">values</span> <span class="o">+</span> <span class="p">(</span><span class="mi">1</span> <span class="o">-</span> <span class="nb">sum</span><span class="p">(</span><span class="n">values</span><span class="p">),))</span>
                <span class="c1"># print(values)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;ERROR - DETERMINISTIC COMPARTMENT MODEL MUST NOT&#39;</span>
                  <span class="s1">&#39; TRY TO HANDLE SEPARATE SUBPOPULATIONS&#39;</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">values</span><span class="p">,</span> <span class="n">method</span>


<div class="viewcode-block" id="EmulsionAgent.evaluate_condition"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.emulsion_agent.EmulsionAgent.evaluate_condition">[docs]</a>    <span class="k">def</span> <span class="nf">evaluate_condition</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">condition</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Return the content (tuple either (&#39;population&#39;, qty) or</span>
<span class="sd">        (&#39;agents&#39;, list)) if the condition is fulfilled, () otherwise.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="n">callable</span><span class="p">(</span><span class="n">condition</span><span class="p">):</span>
            <span class="n">condition</span> <span class="o">=</span> <span class="n">condition</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_content</span><span class="p">()</span> <span class="k">if</span> <span class="n">condition</span> <span class="k">else</span> <span class="p">()</span></div>

<div class="viewcode-block" id="EmulsionAgent.evaluate_event"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.emulsion_agent.EmulsionAgent.evaluate_event">[docs]</a>    <span class="k">def</span> <span class="nf">evaluate_event</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Evaluate if the specified event name is fulfilled, using a</span>
<span class="sd">        calendar. The calendar is determined dynamically according to</span>
<span class="sd">        the name of the event.</span>

<span class="sd">        TAG: USER</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># print(self, &#39;evaluating event&#39;, name, &quot;at&quot;, self.statevars.step)</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">get_calendar_for_event</span><span class="p">(</span><span class="n">name</span><span class="p">)[</span><span class="n">name</span><span class="p">](</span><span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">step</span><span class="p">)</span></div>

<div class="viewcode-block" id="EmulsionAgent.is_in_state"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.emulsion_agent.EmulsionAgent.is_in_state">[docs]</a>    <span class="k">def</span> <span class="nf">is_in_state</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">state_name</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Evaluate if the agent is in the specified state. The state name is</span>
<span class="sd">        expected to be a valid state of one of the state machines. If</span>
<span class="sd">        so, the name of the state machine is expected to be one of the</span>
<span class="sd">        statevars of the agent.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># retrieve name of the state machine associated with the state_name</span>
        <span class="n">varname</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_model_value</span><span class="p">(</span><span class="n">state_name</span><span class="p">)</span><span class="o">.</span><span class="n">state_machine</span><span class="o">.</span><span class="n">machine_name</span>
        <span class="n">result</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="p">[</span><span class="n">varname</span><span class="p">]</span><span class="o">.</span><span class="n">name</span> <span class="o">==</span> <span class="n">state_name</span>\
                 <span class="k">if</span> <span class="n">varname</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span> <span class="k">else</span> <span class="kc">False</span>
        <span class="c1"># print(self, &#39;testing var:&#39;, varname, &#39; = &#39;, result)</span>
        <span class="k">return</span> <span class="n">result</span></div>

    <span class="c1"># def time_before_event(self, event_name):</span>
    <span class="c1">#     &quot;&quot;&quot;Return the time to wait from the current time to the specified</span>
    <span class="c1">#     *event_name*.</span>
    <span class="c1">#     &quot;&quot;&quot;</span>
    <span class="c1">#     pass self.model.get_cal</span>

<div class="viewcode-block" id="EmulsionAgent.get_outbox"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.emulsion_agent.EmulsionAgent.get_outbox">[docs]</a>    <span class="k">def</span> <span class="nf">get_outbox</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Return the content of the outbox.</span>

<span class="sd">        TAG: USER</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">_outbox</span></div>

<div class="viewcode-block" id="EmulsionAgent.add_outbox"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.emulsion_agent.EmulsionAgent.add_outbox">[docs]</a>    <span class="k">def</span> <span class="nf">add_outbox</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">message</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Appendd a message to the outbox.</span>

<span class="sd">        TAG: USER</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">_outbox</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">message</span><span class="p">)</span></div>

<div class="viewcode-block" id="EmulsionAgent.reset_outbox"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.emulsion_agent.EmulsionAgent.reset_outbox">[docs]</a>    <span class="k">def</span> <span class="nf">reset_outbox</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Reset the content of the outbox.</span>

<span class="sd">        TAG: USER</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_outbox</span> <span class="o">=</span> <span class="p">[]</span></div>

<div class="viewcode-block" id="EmulsionAgent.add_inbox"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.emulsion_agent.EmulsionAgent.add_inbox">[docs]</a>    <span class="k">def</span> <span class="nf">add_inbox</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">messages</span><span class="o">=</span><span class="p">[]):</span>
        <span class="sd">&quot;&quot;&quot;Add the specified list of messages in the inbox.</span>

<span class="sd">        TAG: USER&quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_inbox</span> <span class="o">+=</span> <span class="n">messages</span></div>

<div class="viewcode-block" id="EmulsionAgent.clean_inbox"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.emulsion_agent.EmulsionAgent.clean_inbox">[docs]</a>    <span class="k">def</span> <span class="nf">clean_inbox</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Remove non sticky messages from the inbox.</span>

<span class="sd">        TAG: USER</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_inbox</span> <span class="o">=</span> <span class="p">[</span><span class="n">message</span> <span class="k">for</span> <span class="n">message</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">_inbox</span> <span class="k">if</span> <span class="n">message</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;sticky&#39;</span><span class="p">)]</span></div>

<div class="viewcode-block" id="EmulsionAgent.checkout_inbox"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.emulsion_agent.EmulsionAgent.checkout_inbox">[docs]</a>    <span class="k">def</span> <span class="nf">checkout_inbox</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Pick up agent&#39;s inbox content.</span>

<span class="sd">        TAG: USER</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">for</span> <span class="n">message</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">_inbox</span><span class="p">:</span>
            <span class="k">for</span> <span class="n">name</span><span class="p">,</span> <span class="n">value</span> <span class="ow">in</span> <span class="n">message</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">set_information</span><span class="p">(</span><span class="n">name</span><span class="p">,</span> <span class="n">value</span><span class="p">)</span></div></div>
</pre></div>

          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../../../index.html">EMULSION</a></h1>



<p class="blurb">Epidemiological Multi-Level Simulation Framework</p>






<h3>Navigation</h3>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/Information.html">1. Information</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/Install.html">2. Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/Getting_started.html">3. Getting started with EMULSION</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/Modelling_principles.html">4. Modelling principles</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/Modelling_language_basics.html">5. Modelling language (basics)</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/Modelling_language_advanced.html">6. Modelling language (advanced)</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/Feature_examples.html">7. Feature examples</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/Release_notes.html">8. Release notes</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/License.html">9. License</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../emulsion_for_modellers.html">10. High-level functions for model designers</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../emulsion.html">11. emulsion package</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../../../index.html">Documentation overview</a><ul>
  <li><a href="../../../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../../../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2016, INRAE and Univ. Lille.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 1.8.5</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.10</a>
      
    </div>

    

    
  </body>
</html>